class Font {
  final String imageName;
  final int cellWidth, cellHeight;
  final int nCellsW, nCellsH;

  const Font(this.imageName, this.cellWidth, this.cellHeight, this.nCellsW,
      this.nCellsH);

  static const Font bg = Font("assets/images/fonts/font_bg.png", 1, 1, 1, 1);
  static const Font small =
      Font("assets/images/fonts/font_small.png", 1, 1, 16, 16);
  static const Font normal = Font("assets/images/fonts/font.png", 1, 2, 32, 8);
  static const Font big = Font("assets/images/fonts/font_big.png", 2, 2, 32, 8);
}
