part of '../terminal.dart';

class Tile {
  Content? content;

  Color bg = Palette.defaultBg;
  Color fg = Palette.defaultFg;

  int? highlightGroup;

  List<Act> actions = [];

  Tile();

  Tile fadeDisable() {
    var t2 = Tile();
    t2.content = content;
    t2.bg = bg;
    t2.fg = fg;
    // no highlight group, no actions
    return t2;
  }
}

class Content {
  final String sourceImage;
  final int sourceCx;
  final int sourceCy;

  const Content(this.sourceImage, this.sourceCx, this.sourceCy);
}
